//<c>   Copyright 1985-2000 by Gerry J. Danen; all rights reserved.

//<t>   Trash an entire sub-directory structure
//
//      ZAP will erase every file in a subdirectory tree and then remove the
//      subdirectories as well.
//
//      There seems to be a bug in this version that screws up the recursion...


#include"gd_tools.h"
#include"gd_extrn.h"
#include"gd_kb.h"


#if     (! LARGE_MODEL)
  #error LARGE MEMORY MODEL REQUIRED
#endif


#define pgVERS_ "V2.51"
#define pgTITL_ "Zap Directories & Files"
#define pgCOPR_ "1985"


#define         STR_SZ_         133             //  string size
#define         MAX_LEVELS_     30              //  maximum nested directory levels
struct find_t   z_dta [MAX_LEVELS_] ;
int             z_done[MAX_LEVELS_] ;
int             deep=0 ;
BOOL            just_files = FALSE, quiet_mode = FALSE, ynAutomatic = FALSE ;
ULONG           deleted_files = 0, deleted_dirs = 0 ;
UCHAR           fdate_str[12], ftime_str[8], fsize_str[21], fmt[41], curdir[FS_LEN] ;


void    do_help( void )
{
    logon(1);
    printf(
        "%s completely removes a directory along with its files and sub-directories,\n"
        "and its files and sub-directories, etc.  Hidden, system, and read-only files\n"
        "are removed too!  MAKE SURE YOU KNOW WHAT YOU'RE DOING!!!\n\n"
        "Usage:\n\t%s path [path1]...[pathN]\n\n\twhere path is like C:\\TEMP\n\n",
        get_global_program_name(), get_global_program_name() );
    printf(
        "/Q is the QUIET mode.  It will suppress showing the files deleted.\n"
        "/Y will AUTOMATICALLY do what you tell %s to do.  It will NOT stop for\n"
        "confirmation!\n"
        "/F deletes just the files and leaves the directory structure intact.\n"
        "All switches work as toggles and must precede the directory name they are\n"
        "to affect.\n\n"
        "Refer to the docs for more information.\n\n",
        get_global_program_name() );

    exit( GD_ERROR_HELP );
}


STRING  date_of_file( unsigned fdate, STRING presult )
{
    static STRING months[] =
    {
        "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"
    };
    struct  fileDateStruc
    {
        unsigned d : 5 ;
        unsigned m : 4 ;
        unsigned y : 7 ;
    };
    union   fileDateUnion                       // date union
    {
        struct fileDateStruc dt ;
        unsigned    pdt;
    }   fldate ;
    int  month, day, year ;

    fldate.pdt = fdate ;
    day    = fldate.dt.d ;
    month  = fldate.dt.m ;
    year   = fldate.dt.y + 1980 ;
    sprintf( presult, "%02d-%3s-%04d", day, months[month-1], year );
    return( presult );
}


STRING  time_of_file( unsigned ftime, STRING presult )
{
    struct  fileTimeStruc
    {
        unsigned ss : 5 ;
        unsigned mm : 6 ;
        unsigned hh : 5 ;
    };
    union   fileTimeUnion
    {
        struct fileTimeStruc tm ;
        unsigned    ptm;
    }   fltime ;
    char AorP ;
    int  hour, minute ;

    fltime.ptm = ftime ;
    hour   = fltime.tm.hh ;
    minute = fltime.tm.mm ;
    AorP = (char) ((hour < 12) ? 'a' : 'p');
    hour %= 12 ;
    if ( hour == 0 )
        hour = 12 ;
    sprintf( presult, "%02d:%02d%cm", hour, minute, AorP );
    return( presult );
}


/*
        This function removes all files from the current directory first.
        Then, if there are sub-directories, zapdir() changes to it and
        calls itself recursively.  Upon return, the zapped sub-directory
        is removed.
        VERY DANGEROUS!!!
*/


void    zapdir( void )
{
    UCHAR       filename[FS_LEN] ;
    int         levl ;

    levl = MAX_FNAME+MAX_EXT-2 ;
    sprintf( fmt, "      %%-%d.%ds  %%s  %%s  %%13s\n", levl, levl );
    _getcwd( curdir, FS_LEN );
    deep += 1 ;
    if ( deep > MAX_LEVELS_ )
    {
        printf( "\a\nMaximum %d nested directory levels\n", MAX_LEVELS_ );
        return ;
    }
    levl = deep - 1 ;

    printf( "\n%s%s\n", curdir, ( strlen(curdir) > 2 ? "" : "\\" ) );

    z_done[levl] = _dos_findfirst( "*.*", 47, &z_dta[levl] );
    while ( ! z_done[levl] )
    {
        if ( ! ((z_dta[levl].attrib & _A_SUBDIR) == _A_SUBDIR) )
        {
            strcpy( filename, z_dta[levl].name );
            _strlwr( filename );
            if ( ! quiet_mode )
                printf( fmt, filename,
                        date_of_file(z_dta[levl].wr_date, fdate_str),
                        time_of_file(z_dta[levl].wr_time, ftime_str),
                        Format_INT32((INT32) z_dta[levl].size, fsize_str) );
            sprintf( filename, "%s\\%s", curdir, z_dta[levl].name );
            SetAttrib( filename, -1, -1, -1, -1 );
            fl_delete( filename );
            deleted_files += 1 ;
        }
        z_done[levl] = _dos_findnext( &z_dta[levl] );
    }
    z_done[levl] = _dos_findfirst( "*.*", _A_SUBDIR+_A_HIDDEN+_A_SYSTEM, &z_dta[levl] );
    while ( ! z_done[levl] )
    {
        if ( ((z_dta[levl].attrib & _A_SUBDIR) == _A_SUBDIR) && (z_dta[levl].name[0] != '.') )
        {
            _chdir( z_dta[levl].name );
            zapdir();
            deep -= 1 ;
            _chdir( ".." );
            if ( ! just_files )
            {
                SetAttrib( z_dta[levl].name, -1, -1, -1, -1 );
                _rmdir( z_dta[levl].name );
                deleted_dirs += 1 ;
            }
            _getcwd( curdir, FS_LEN );
        }
        z_done[levl] = _dos_findnext( &z_dta[levl] );
    }
}


void    do_switch( STRING par )
{
    UCHAR       p ;

    while ( *par )
    {
        p = *par++ ;
        switch ( p )
        {
            case 'F' :
                just_files = ( ! just_files );
                break ;
            case 'Q' :
                quiet_mode = ( ! quiet_mode );
                break ;
            case 'Y' :
                ynAutomatic = ( ! ynAutomatic );
                break ;
            default  :
                logon(1);
                printf( "\nSwitch \"%c\" is not legal.\a\n\n", p );
            case '?' :
            case 'H' :
                do_help();
        }
    }
}


void    do_process( STRING spec )
{
    char        origdir[FS_LEN], target[FS_LEN], trashdir[FS_LEN] ;
    int         problem, i, reply ;
    UINT        drv, numofdrives ;
    ULONG       kb_freed ;
    UCHAR       kb_freed_s[15] ;
    struct diskfree_t drv_info1, drv_info2 ;

    strcpy( trashdir, spec );

    if ( ! dr_is_directory( trashdir ) )
    {
        printf( "Directory %s does not exist!\n", trashdir );
        return ;
    }

    i = strlen( trashdir );
    if ( (trashdir[i-1] == '\\') && (i != 3) )
        trashdir[i-1] = 0;
    if ( just_files )
        printf( "\nAbout to delete all files in \"%s\",\nalong with all files from its subdirectories.", trashdir );
    else
        printf( "\nAbout to remove \"%s\" with all subdirectories and files.", trashdir );
    printf( "\nThis is a dangerous operation!\nPress Y to trash \"%s\" or any other key to quit...\a", trashdir );
    if ( ynAutomatic )
        reply = (int)'Y' ;
    else
        reply = _getch();
    if ( (int)toupper(reply) != (int)'Y' )
    {
        printf( "Cancelled!\n" );
        return ;
    }
    printf( "\n" );

    deleted_files = deleted_dirs = 0 ;
    deep = 0;                                   // Not nested any levels
    _getcwd( origdir, FS_LEN );                 // Get current directory
    if ( trashdir[1] == ':' )
        _dos_setdrive( trashdir[0] - 64, &numofdrives );    // Go to drive
    _getcwd( target, FS_LEN );                  // Get the current path there
    problem = _chdir( trashdir );               // Switch to specified path
    if ( ! problem )                            // If no problem encountered
    {
        drv = CurrentDrive();
        printf( "Wait..." );
        _dos_getdiskfree( drv, &drv_info1 );
        printf( "\r\t\t\r" );
        zapdir();                               // invoke procedure
        _chdir( ".." );                         // up one level
        if ( ! just_files )
        {
            SetAttrib( trashdir, -1, -1, -1, -1 );
            _rmdir( trashdir );                 // remove the directory
            deleted_dirs += 1 ;
        }
        _dos_getdiskfree( drv, &drv_info2 );
        if ( drv_info2.avail_clusters == drv_info1.avail_clusters )
        {
            strcpy( kb_freed_s, "0" );
        }
        else
        {
            kb_freed = (ULONG) ((ULONG) (drv_info2.avail_clusters-drv_info1.avail_clusters) * (ULONG) drv_info1.sectors_per_cluster * (ULONG) drv_info1.bytes_per_sector) / ((ULONG) 1024) ;
            Format_INT32( (INT32) kb_freed, kb_freed_s );
        }
        printf( "\n %s Kbyte%s freed from %lu director%s and %lu file%s\n",
                kb_freed_s,    ((kb_freed == (INT32) 1) ? "" : "s"),
                deleted_dirs,  ((deleted_dirs == (ULONG) 1) ? "y" : "ies"),
                deleted_files, ((deleted_files == (ULONG) 1) ? "" : "s") );
    }
    else
    {
        printf( "Internal problem: could not locate %s\a\n", trashdir );
    }

    _dos_setdrive( origdir[0] - 64, &numofdrives ); // Go to orig drive &

    if ( (strlen(origdir) == 2) && (origdir[1] == ':') )
        _chdir( "\\" );                         // root directory or
    else
        _chdir( origdir );                      // original path from where
                                                // the utility was called.
}


void    main( int argc, char *argv[] )
{
    UCHAR       a[ STR_SZ_ ] ;

    tt_init( SHAREWARE_VERSION, 0, pgVERS_, pgTITL_, pgCOPR_ );
    logon(0);

    if ( argc < 2 )
        do_help();

    argc = 1 ;
    while ( strlen(argv[argc]) )
    {
        st_cpy( a, argv[argc++], STR_SZ_ );
        _strupr( a );
        if ( (a[0] == '/') || (a[0] == '-') )
            do_switch( &a[1] );
        else
            do_process( a );
    }
    exit( 0 );
}
